Attribute VB_Name = "IniFile"
Option Explicit
'+++++++++++++++++++++++++++++++++++++++++++++++++++
'+    VB6  ..  . +
'+++++++++++++++++++++++++++++++++++++++++++++++++++

'     Win.INI
Public Declare Function GetProfileInt Lib "kernel32" Alias "GetProfileIntA" (ByVal lpAppName As String, ByVal lpKeyName As String, ByVal nDefault As Long) As Long
'    Win.INI
Public Declare Function GetProfileSection Lib "kernel32" Alias "GetProfileSectionA" (ByVal lpAppName As String, ByVal lpReturnedString As String, ByVal nSize As Long) As Long
'    Win.INI
Public Declare Function GetProfileString Lib "kernel32" Alias "GetProfileStringA" (ByVal lpAppName As String, ByVal lpKeyName As String, ByVal lpDefault As String, ByVal lpReturnedString As String, ByVal nSize As Long) As Long
'      .INI
Public Declare Function GetPrivateProfileInt Lib "kernel32" Alias "GetPrivateProfileIntA" (ByVal lpApplicationName As String, ByVal lpKeyName As String, ByVal nDefault As Long, ByVal lpFileName As String) As Long
'     .INI
Public Declare Function GetPrivateProfileSection Lib "kernel32" Alias "GetPrivateProfileSectionA" (ByVal lpAppName As String, ByVal lpReturnedString As String, ByVal nSize As Long, ByVal lpFileName As String) As Long
'     .INI
Public Declare Function GetPrivateProfileString Lib "kernel32" Alias "GetPrivateProfileStringA" (ByVal lpApplicationName As String, ByVal lpKeyName As String, ByVal lpDefault As String, ByVal lpReturnedString As String, ByVal nSize As Long, ByVal lpFileName As String) As Long
'     .INI
Public Declare Function WritePrivateProfileSection Lib "kernel32" Alias "WritePrivateProfileSectionA" (ByVal lpAppName As String, ByVal lpString As String, ByVal lpFileName As String) As Long
'     .INI
Public Declare Function WritePrivateProfileString Lib "kernel32" Alias "WritePrivateProfileStringA" (ByVal lpApplicationName As String, ByVal lpKeyName As String, ByVal lpString As Any, ByVal lpFileName As String) As Long
'    Win.INI
Public Declare Function WriteProfileSection Lib "kernel32" Alias "WriteProfileSectionA" (ByVal lpAppName As String, ByVal lpString As String) As Long
'    Win.INI
Public Declare Function WriteProfileString Lib "kernel32" Alias "WriteProfileStringA" (ByVal lpszSection As String, ByVal lpszKeyName As String, ByVal lpszString As String) As Long
'     Win.ini      
Public Declare Function PostMessageByString Lib "user32" Alias "PostMessageA" (ByVal hwnd As Long, ByVal wMsg As Long, ByVal wParam As Long, ByVal lParam As String) As Long
Public Const WM_WININICHANGE = &H1A
Public Const HWND_BROADCAST = &HFFFF&


'+++++++++++++++++++++++++++++++++++++++++++++++++
'   ()  .ini
'=================================================

Public Function IniLongPrivate(SekName As String, KeyName As String, IniFileName As String) As Long
'      .INI
'-------------------------------------------------
'SekName -   (  )
'KeyName -   (  )
'9999    -   ,    
'IniFileName -   .ini (     ,    Windows)
IniLongPrivate = GetPrivateProfileInt(SekName, KeyName, 9999, IniFileName)
End Function

Public Function IniStringPrivate(SekName As String, KeyName As String, IniFileName As String) As String
'      .INI
'-------------------------------------------------
'SekName -   (  )
'KeyName -   (  )
'" "    -   ,    
'IniFileName -   .ini (     ,    Windows)

Dim sTemp As String * 256 ' (  )
Dim nTemp As Integer '       

nTemp = GetPrivateProfileString(SekName, KeyName, " ", sTemp, 255, IniFileName)
IniStringPrivate = Left$(sTemp, nTemp)
' -      255 
End Function

Public Function IniMassivPrivate(SekName As String, IniFileName As String) As String
'      
'  ,    .INI
'-------------------------------------------------
'SekName -   (  )
'IniFileName -   .ini (     ,    Windows)
'+++++++++++++++++++++++++++++++++++++++++++++++++
'       ,
'  -,  -
'  .
Dim sTemp As String * 256 ' ( ){ Win95  32767}
Dim nTemp As Integer '       

nTemp = GetPrivateProfileSection(SekName, sTemp, 255, IniFileName)

'      
'  {-}  {;}(    )
IniMassivPrivate = Replace(Left$(sTemp, nTemp), Chr$(0), ";")

End Function

Public Function IniMassSecionPrivate(IniFileName As String) As String
'        .INI
'-------------------------------------------------
'IniFileName -   .ini (     ,    Windows)
'+++++++++++++++++++++++++++++++++++++++++++++++++
'     ,
'  -,  -
'  .
Dim sTemp As String * 256 ' ( ){ Win95  32767}
Dim nTemp As Integer '       

nTemp = GetPrivateProfileString(vbNullString, "", "", sTemp, 255, IniFileName)

'      
'  {-}  {;}(    )
IniMassSecionPrivate = Replace(Left$(sTemp, nTemp), Chr$(0), ";")

End Function

Public Function IniMassKeyPrivate(SekName As String, IniFileName As String) As String
'         .INI
'-------------------------------------------------
'IniFileName -   .ini (     ,    Windows)
'SekName -   (  )
'+++++++++++++++++++++++++++++++++++++++++++++++++
'     ,
'  -,  -
'  .
Dim sTemp As String * 256 ' ( ){ Win95  32767}
Dim nTemp As Integer '       

nTemp = GetPrivateProfileString(SekName, vbNullString, "", sTemp, 255, IniFileName)

'      
'  {-}  {;}(    )
IniMassKeyPrivate = Replace(Left$(sTemp, nTemp), Chr$(0), ";")

End Function

Public Function IniWriteStrPrivate(SekName As String, KeyName As String, Param As String, IniFileName As String) As Long
'      .INI
'-------------------------------------------------
'SekName -   (  )
'KeyName -   (  )
'Param   - ,   (  )
'IniFileName -   .ini (     ,    Windows)

Dim nTemp As Long
'   ,     Param
If Param <> "" Then
    nTemp = WritePrivateProfileString(SekName, KeyName, Param, IniFileName)
    IniWriteStrPrivate = 1
Else
    IniWriteStrPrivate = 0
End If
End Function

Public Function IniWriteMassPrivate(SekName As String, Mass As String, IniFileName As String) As Long
'         .INI
'    
'-------------------------------------------------
'SekName -   (  )
'Mass   -      (  )
'IniFileName -    .ini

Dim nTemp As Long
Dim nError As Long
'    ()
If Mass = "" Then
    nError = 1 '-  (   )
Else
    If Right$(Mass, 2) <> ";;" Then
        nError = 2 '-    (;;)
    End If
End If
If Dir$(IniFileName, vbNormal) = "" Then nError = 3 '-    .ini
If SekName = "" Then nError = 4 '-  
If nError = 0 Then
Mass = Replace(Mass, ";", Chr$(0))
    nTemp = WritePrivateProfileSection(SekName, Mass, IniFileName)
    IniWriteMassPrivate = nError
Else
IniWriteMassPrivate = nError
End If

End Function

Public Function IniDelKeyPrivate(SekName As String, KeyName As String, IniFileName As String)
'        .INI
'-------------------------------------------------
'SekName -   (  )
'KeyName -   (  )
'IniFileName -   .ini (     ,    Windows)

Dim nTemp As Long
nTemp = WritePrivateProfileString(SekName, KeyName, vbNullString, IniFileName)

End Function

Public Function IniDelAllKeyPrivate(SekName As String, IniFileName As String)
'         .INI
'    !
'-------------------------------------------------
'SekName -   (  )
'IniFileName -   .ini (     ,    Windows)

Dim nTemp As Long
nTemp = WritePrivateProfileString(SekName, vbNullString, vbNullString, IniFileName)

End Function
Public Function IniNewSekPrivate(SekName As String, IniFileName As String)
'   ()    .INI
'   - "  "
'-------------------------------------------------
'SekName -   (  )
'IniFileName -   .ini (     ,    Windows)

Dim nTemp As Long
    
    nTemp = WritePrivateProfileString(SekName, "xxxx", "xxxx", IniFileName)
    nTemp = WritePrivateProfileString(SekName, "xxxx", vbNullString, IniFileName)

End Function

'\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\
'|              Win.ini                 |
'+++++++++++++++++++++++++++++++++++++++++++++++++++++
'|       Win.in |
'|  .                                 |
'|+++++++++++++++++++++++++++++++++++++++++++++++++++|
'|      Win.in     |
'|    WM_WININICHANGE  |
'|     .             |
'////////////////////////////////////////////////////

Public Function WinIniMessage(SekName As String)
'     Win.ini   
'SekName -   (  )
Dim nTemp As Long
nTemp = PostMessageByString(HWND_BROADCAST, WM_WININICHANGE, 0, SekName)
End Function

Public Function WinIniNewSeksion(SekName As String)
'  ()   Win.in
'   "  "
'-------------------------------------------------
'SekName -   (  )
Dim nTemp As Long
    
nTemp = WriteProfileString(SekName, "xxxxx", "xxxxx")
nTemp = WriteProfileString(SekName, "xxxxx", vbNullString)

End Function

Public Function WinIniDelSeksion(SekName As String)
'    .
'-------------------------------------------------
'SekName -   (  )
Dim nTemp As Long
    
nTemp = WriteProfileString(SekName, vbNullString, vbNullString)

End Function

Public Function WinIniDelKey(SekName As String, KeyName As String)
'    .
'-------------------------------------------------
'SekName -   (  )
'KeyName -   (  )
Dim nTemp As Long
    
nTemp = WriteProfileString(SekName, KeyName, vbNullString)

End Function

Public Function WinIniWriteKeyString(SekName As String, KeyName As String, Param As String)
' (  )      .
'-------------------------------------------------
'SekName -   (  )
'KeyName -   (  )
'Param   -   
Dim nTemp As Long
    
nTemp = WriteProfileString(SekName, KeyName, Param)

End Function

Public Function WinIniWriteMassString(SekName As String, Mass As String)
'       Win.ini
'    
'        
'-------------------------------------------------
'SekName -   (  )
'Mass   -      (  )

Dim nTemp As Long
Dim nError As Long
'    ()
If Mass = "" Then
    nError = 1 '-  (   )
Else
    If Right$(Mass, 2) <> ";;" Then
        nError = 2 '-    (;;)
    End If
End If
If SekName = "" Then nError = 4 '-  
If nError = 0 Then
Mass = Replace(Mass, ";", Chr$(0))
    nTemp = WriteProfileSection(SekName, Mass)
End If
End Function

Public Function WinIniLong(SekName As String, KeyName As String) As Long
'      .INI
'-------------------------------------------------
'SekName -   (  )
'KeyName -   (  )
'9999    -   ,    
WinIniLong = GetProfileInt(SekName, KeyName, 9999)
End Function
Public Function WinIniString(SekName As String, KeyName As String) As String
'     Win.ini
'-------------------------------------------------
'SekName -   (  )
'KeyName -   (  )
'" "    -   ,    

Dim sTemp As String * 256 ' (  )
Dim nTemp As Integer '       

nTemp = GetProfileString(SekName, KeyName, " ", sTemp, 255)
WinIniString = Left$(sTemp, nTemp)
' -      255 
End Function

Public Function WinIniMassiv(SekName As String) As String
'      
'  ,   Win.ini
'-------------------------------------------------
'SekName -   (  )
'+++++++++++++++++++++++++++++++++++++++++++++++++
'       ,
'  -,  -
'  .
Dim sTemp As String * 256 ' ( ){ Win95  32767}
Dim nTemp As Integer '       

nTemp = GetProfileSection(SekName, sTemp, 255)

'      
'  {-}  {;}(    )
WinIniMassiv = Replace(Left$(sTemp, nTemp), Chr$(0), ";")
End Function

Public Function WinIniMassSecion() As String
'       Win.ini
'+++++++++++++++++++++++++++++++++++++++++++++++++
'     ,
'  -,  -
'  .
Dim sTemp As String * 512 ' ( ){ Win95  32767}
Dim nTemp As Integer '       

nTemp = GetProfileString(vbNullString, "", "", sTemp, 511)

'      
'  {-}  {;}(    )
WinIniMassSecion = Replace(Left$(sTemp, nTemp), Chr$(0), ";")
End Function

Public Function WinIniMassKey(SekName As String) As String
'         Win.ini
'+++++++++++++++++++++++++++++++++++++++++++++++++
'SekName -   (  )
'     ,
'  -,  -
'  .
Dim sTemp As String * 512 ' ( ){ Win95  32767}
Dim nTemp As Integer '       

nTemp = GetProfileString(SekName, vbNullString, "", sTemp, 511)

'      
'  {-}  {;}(    )
WinIniMassKey = Replace(Left$(sTemp, nTemp), Chr$(0), ";")
End Function

